]> arthur.barton.de Git - backup-script.git/blob - bin/backup-script
9a8ad2bb0890544101fe50290b5a3aca054ed68f
[backup-script.git] / bin / backup-script
1 #!/bin/bash
2 #
3 # backup-script system for cloning systems using rsync
4 # Copyright (c)2008-2015 Alexander Barton <alex@barton.de>
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12
13 NAME=$(basename "$0")
14 PIDFILE="/var/run/$NAME.pid"
15
16 DRYRUN=0
17 VERBOSE=0
18
19 export LC_ALL=C
20
21 declare -i count_all=0
22 declare -i count_started=0
23 declare -i count_ok=0
24 declare -i count_ok_vanished=0
25
26 destinations=""
27
28 # Default settings, can be overwritten in backup-script.conf:
29 [ -d "/usr/local/etc/backup-script.d" ] \
30         && conf_d="/usr/local/etc/backup-script.d" \
31         || conf_d="/etc/backup-script.d"
32 pre_exec=""
33 post_exec=""
34 default_source_root="/"
35 default_target="/var/backups"
36 default_user="root"
37 default_ssh_args_add=""
38 default_rsync_args_add=""
39 default_exclude_args_add=""
40 default_compress=1
41 default_ping=1
42 default_local=0
43 default_generations=0
44 default_job_pre_exec=""
45 default_job_post_exec=""
46
47 Usage() {
48         echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
49         echo
50         echo "  -p, --progress    Show progress, see rsync(1)."
51         echo "  -n, --dry-run     Test run only, don't copy any data."
52         echo
53         echo "When no <system> is given, all defined systems are used."
54         echo
55         echo "Configuration file is \"$conf\","
56         echo "using \"$conf_d\" as configuration directory."
57         echo
58         exit 1
59 }
60
61 CleanUp() {
62         if [ -n "$post_exec" ]; then
63                 echo "Executing \"$post_exec\" ..."
64                 sh -c $post_exec
65                 if [ $? -ne 0 ]; then
66                         echo "Warning: post-exec command failed!"
67                 fi
68                 echo
69         fi
70         rm -f "$PIDFILE"
71 }
72
73 GotSignal() {
74         echo
75         echo "--> Got break signal, cleaning up & aborting ..."
76         echo
77         CleanUp
78         echo -n "Aborted: "; date
79         echo
80         sleep 3
81         exit 9
82 }
83
84 ExecJob() {
85         local what="$1"
86         local cmd="$2"
87
88         echo "Running job ${what}-exec command ..."
89         [ "$local" -eq 0 ] \
90                 && cmd="$ssh_cmd ${user}@${system} $cmd"
91         echo -n "Start date (${what}-exec): "; date
92         echo "$cmd"
93         if [ "$DRYRUN" -eq 0 ]; then
94                 $SHELL -c "$cmd"; local ret=$?
95         else
96                 echo " *** Trial run, not executing ${what}-exec command!"
97                 ret=0
98         fi
99         [ $ret -eq 0 ] \
100                 && echo "The ${what}-exec command completed with status 0, OK." \
101                 || echo "The ${what}-exec command completed with ERRORS, code $ret!"
102         return $ret
103 }
104
105 GetFS() {
106         local dir="$1"
107
108         while [ -n "$dir" ]; do
109                 findmnt -fn -o FSTYPE --raw "$dir" 2>/dev/null; local r=$?
110                 if [ $r -eq 0 ]; then
111                         return 0
112                 elif [ $r -eq 127 ]; then
113                         echo "UNKNOWN"
114                         return 1
115                 fi
116                 dir=$(dirname "$dir") || return 1
117         done
118 }
119
120 CreateSubvolume() {
121         local volume="$1"
122         local fs
123         local dir
124
125         dir=$(dirname "$volume")
126         fs=$(GetFS "$dir")
127         case "$fs" in
128           "btrfs")
129                 btrfs subvolume create "$volume"  >/dev/null || return 1
130                 ;;
131           "zfs")
132                 zfs create "$(echo "$volume" | cut -c2-)" || return 1
133                 ;;
134           *)
135                 echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
136                 return 9
137         esac
138         return 0
139 }
140
141 CloneSubvolume() {
142         local source="$1"
143         local volume="$2"
144         local snapshot="$3"
145         local dir
146         local fs
147         local link_name
148
149         dir=$(dirname "source")
150         fs=$(GetFS "$source")
151         case "$fs" in
152           "btrfs")
153                 btrfs subvolume snapshot "$source" "$snapshot"  >/dev/null || return 1
154                 ;;
155           "zfs")
156                 zfs snapshot "$snapshot" || return 1
157                 link_name="$(echo "$snapshot" | cut -d@ -f2-)"
158                 ln -s \
159                         "$volume/.zfs/snapshot/$link_name" \
160                         "$(dirname "$volume")/$link_name"
161                 ;;
162           *)
163                 echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
164                 return 9
165         esac
166         return 0
167 }
168
169 RenameSubvolume() {
170         local source="$1"
171         local target="$2"
172         local fs
173
174         fs=$(GetFS "$source")
175         case "$fs" in
176           "btrfs")
177                 mv "$source" "$target" || return 1
178                 ;;
179           "zfs")
180                 zfs rename \
181                   "$(echo "$source" | cut -c2-)" \
182                   "$(echo "$target" | cut -c2-)" \
183                         || return 1
184                 ;;
185           *)
186                 echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
187                 return 9
188         esac
189         return 0
190 }
191
192 DeleteSubvolume() {
193         local volume="$1"
194         local fs
195         local id
196         local snapshot
197
198         fs=$(GetFS "$volume")
199         case "$fs" in
200           "btrfs")
201                 btrfs subvolume delete "$volume" >/dev/null || return 1
202                 ;;
203           "zfs")
204                 id="$(basename "$volume")"
205                 if [ -h "$volume" ]; then
206                         snapshot="$(dirname "$volume")/current@$id"
207                 else
208                         snapshot="$volume"
209                 fi
210                 zfs destroy -r "$(echo "$snapshot" | cut -c2-)" >/dev/null || return 1
211                 [ -h "$volume" ] && rm "$volume"
212                 ;;
213           *)
214                 echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
215                 return 9
216         esac
217         return 0
218 }
219
220 Initialize_Last_SysTarget_Snapshot() {
221         sys_target="$1"
222         unset last
223         unset snapshot
224
225         fs=$(GetFS "$sys_target")
226         case "$fs" in
227           "btrfs")
228                 # Search directory of last generation, if any
229                 last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
230                 if [ -n "$last" ]; then
231                         if [ ! -d "$last" ]; then
232                                 echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
233                                 echo
234                                 return 1
235                         fi
236                 fi
237                 sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
238                 snapshot="$sys_target"
239                 ;;
240           "zfs")
241                 # On ZFS, the last generation is always named "current"
242                 if [ -e "$sys_target/current" ]; then
243                         last="$sys_target/current"
244                         if [ "$(uname)" = "Linux" ]; then
245                                 date=$(LC_ALL=C stat "$1" | grep "^Modify: " \
246                                  | cut -d':' -f2- | cut -d. -f1)
247                         else
248                                 date=$(LC_ALL=C stat -f "%Sc" "$1")
249                         fi
250                         date=$(echo "$date" | sed -e's/^ //g' -e 's/[-:]//g' -e 's/ /-/g')
251
252                 else
253                         last=""
254                         date="$(date +%Y%m%d-%H%M%S)"
255                 fi
256                 snapshot="$(echo "$sys_target/current" | cut -c2-)@$date"
257                 sys_target="$sys_target/current"
258                 ;;
259           *)
260                 echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
261                 return 1
262         esac
263         return 0
264 }
265
266 # Search configuration file (last one is used as default!)
267 for conf in \
268         "/usr/local/etc/backup-script.conf" \
269         "${conf_d}/backup-script.conf" \
270         "/etc/backup-script.conf" \
271 ; do
272         [ -r "$conf" ] && break
273 done
274
275 while [ $# -gt 0 ]; do
276         case "$1" in
277           "-n"|"--dry-run")
278                 DRYRUN=1; shift
279                 ;;
280           "-p"|"--progress")
281                 VERBOSE=1; shift
282                 ;;
283           "-"*)
284                 Usage
285                 ;;
286           *)
287                 break
288         esac
289 done
290
291 trap GotSignal SIGINT
292
293 echo -n "Started: "; date
294
295 # Read in configuration file
296 if [ -r "$conf" ]; then
297         echo "Reading configuration: \"$conf\" ..."
298         source "$conf"
299 else
300         echo "No configuration file found, using defaults."
301 fi
302 echo
303
304 if [ $# -ge 1 ]; then
305         for s in "$@"; do
306                 if [ ! -r "${conf_d}/$s" ]; then
307                         echo "$NAME: Can' read \"${conf_d}/$s\"!"
308                         exit 1
309                 fi
310                 sys="$sys ${conf_d}/$s"
311         done
312 else
313         sys="${conf_d}/"*
314 fi
315
316 # check and create PID file
317 if [ -e "$PIDFILE" ]; then
318         echo "Lockfile \"$PIDFILE\" already exists."
319         echo "Is an other instance still running?"
320         echo
321         echo -n "Aborted: "; date
322         echo
323         exit 3
324 fi
325 touch "$PIDFILE" 2>/dev/null
326 if [ $? -ne 0 ]; then
327         echo "Warning: can't create PID file \"$PIDFILE\"!"
328         echo
329 else
330         echo "$$" >>"$PIDFILE"
331 fi
332
333 if [ -n "$pre_exec" ]; then
334         echo "Executing \"$pre_exec\" ..."
335         sh -c $pre_exec
336         if [ $? -ne 0 ]; then
337                 echo "Error: pre-exec command failed!"; echo
338                 CleanUp
339                 echo "Aborting backup."; echo
340                 exit 2
341         fi
342         sleep 2
343         echo
344 fi
345
346 for f in $sys; do
347         [ -r "$f" -a -f "$f" ] || continue
348
349         fname=$(basename "$f")
350         case "$fname" in
351                 "backup-script.conf"|*.sh)
352                         continue
353                         ;;
354         esac
355
356         # Set global defaults
357         system="$fname"
358         user="$default_user"
359         source_root="$default_source_root"
360         target="$default_target"
361         ssh_args_add="$default_ssh_args_add"
362         rsync_args_add="$default_rsync_args_add"
363         exclude_args_add="$default_exclude_args_add"
364         compress="$default_compress"
365         ping="$default_ping"
366         local="$default_local"
367         generations="$default_generations"
368         job_pre_exec="$default_job_pre_exec"
369         job_post_exec="$default_job_post_exec"
370
371         # Compatibility with backup-pull(1) script: Save global values ...
372         pre_exec_saved="$pre_exec"
373         post_exec_saved="$post_exec"
374
375         # Compatibility with backup-pull(1) script: Set defaults
376         unset host
377         unset source
378         unset pre_exec
379         unset post_exec
380
381         # Read in system configuration file
382         source "$f"
383
384         # Compatibility with backup-pull(1) script: Fix up configuration
385         [ "$system" = "$fname" -a -n "$host" ] \
386                 && system="$host"
387         [ "$source_root" = "$default_source_root" -a -n "$source" ] \
388                 && source_root="$source"
389         [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
390                 && job_pre_exec="$pre_exec"
391         [ -z "$job_post_exec" -a -n "$post_exec" ] \
392                 && job_post_exec="$post_exec"
393
394         # Compatibility with backup-pull(1) script: Restore global values ...
395         pre_exec="$pre_exec_saved"
396         post_exec="$post_exec_saved"
397
398         # Validate configuration
399         [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
400
401         # Make sure "source" ends with a slash ("/")
402         case "$source" in
403           "*/")
404                 ;;
405           "*")
406                 source="$source/"
407         esac
408
409         # Make sure "target" DOESN'T end with a slash ("/")
410         case "$target" in
411           "*/")
412                 target=$( echo "$target" | sed -e 's/\/$//g' )
413                 ;;
414         esac
415
416         [ "$system" = "$fname" ] \
417                 && systxt="\"$system\"" \
418                 || systxt="\"$fname\" [\"$system\"]"
419         [ "$local" -eq 0 ] \
420                 && echo "Working on $systxt ..." \
421                 || echo "Working on $systxt (local system) ..."
422
423         count_all=$count_all+1
424
425         # Check target directory
426         if [ -z "$target" ]; then
427                 echo "No target directory specified for \"$system\"!? Skipped!"
428                 echo; continue
429         fi
430         if [ ! -d "$target" ]; then
431                 echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
432                 echo; continue
433         fi
434
435         sys_target="$target/$fname"
436         sys_root="$sys_target"
437         if [ "$DRYRUN" -eq 0 -a ! -e "$sys_target" ]; then
438                 if [ $generations -gt 0 ]; then
439                         CreateSubvolume "$sys_target"
440                 else
441                         mkdir -p "$sys_target"
442                 fi
443                 if [ $? -ne 0 ]; then
444                         echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
445                         echo; continue
446                 fi
447         fi
448
449         if [ "$local" -eq 0 -a "$ping" -ne 0 ]; then
450                 # Check if system is alive
451                 ping -c 1 "$system" >/dev/null 2>&1
452                 if [ $? -ne 0 ]; then
453                         echo "Host \"$system\" seems not to be alive!? Skipped."
454                         echo; continue
455                 fi
456                 echo "OK, host \"$system\" seems to be alive."
457         fi
458
459         if [ $generations -gt 0 ]; then
460                 # Make sure no old backup is stored in system directory
461                 if [ -e "$sys_target/.stamp" ]; then
462                         # There seems to be a genearation-less backup in the
463                         # target directory!
464                         echo "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
465                         echo; continue
466                 fi
467
468                 Initialize_Last_SysTarget_Snapshot "$sys_target" || continue
469
470                 if [ -n "$last" -a ! -e "$last/.stamp" ]; then
471                         # Old backup directory without "stamp file", continue
472                         echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
473                         RenameSubvolume "$last" "$sys_target"
474                         if [ $? -ne 0 ]; then
475                                 echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
476                                 echo; continue
477                         fi
478                 elif [ -n "$last" ]; then
479                         # Old backup directory found, create new snapshot
480                         echo "Found last snapshot in \"$last\"."
481                         if [ "$DRYRUN" -eq 0 ]; then
482                                 CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
483                                 if [ $r -ne 0 ]; then
484                                         echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
485                                         echo; continue
486                                 fi
487                                 echo "Created new snapshot in \"$snapshot\"."
488                         else
489                                 echo " *** Trial run, not creating new snapshot in \"$snapshot\"!"
490                         fi
491                 else
492                         # No old backup found, create new subvolume
493                         if [ "$DRYRUN" -eq 0 ]; then
494                                 CreateSubvolume "$sys_target"; r=$?
495                                 if [ $r -ne 0 ]; then
496                                         echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
497                                         echo; continue
498                                 fi
499                                 echo "Created new subvolume in \"$sys_target\"."
500                         else
501                                 echo " *** Trial run, not creating new subvolume \"$sys_target\"!"
502                         fi
503                 fi
504         fi
505
506         ssh_cmd="ssh"
507         [ -n "$ssh_args_add" ] && ssh_cmd="$ssh_cmd $ssh_args_add"
508
509         # execute job "pre-exec" command, if any
510         if [ -n "$job_pre_exec" ]; then
511                 ExecJob pre "$job_pre_exec" ; ret=$?
512                 if [ $ret -ne 0 ]; then
513                         [ $ret -ne 99 ] && count_started=$count_started+1
514                         echo "Pre-exec command failed, \"$system\" skipped!"
515                         echo; continue
516                 fi
517         fi
518
519         # prepare (remote) command ...
520         cmd="rsync --archive"
521         [ "$compress" -ne 0 ] && cmd="$cmd --compress"
522         [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
523         cmd="$cmd --delete --delete-excluded --sparse"
524         [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
525         if [ "$source_root" = "$default_source_root" ]; then
526                 cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
527                 cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
528                 cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
529                 cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
530         fi
531         [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
532         [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
533
534         [ "$local" -eq 0 ] \
535                 && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
536                 || cmd="$cmd $source_root $sys_target/"
537
538         echo "Backing up to \"$sys_target\" ..."
539         echo -n "Start date: "; date
540         echo "$cmd"
541         count_started=$count_started+1
542         ok=0
543
544         if [ "$DRYRUN" -eq 0 ]; then
545                 rm -f "$sys_target/.stamp"
546                 $SHELL -c "$cmd"; ret=$?
547                 echo "code=$ret" >"$sys_target/.stamp"
548         else
549                 echo " *** Trial run, not executing synchronization command!"
550                 ret=0
551         fi
552
553         if [ $ret -eq 20 ]; then
554                 echo "Backup of \"$system\" interrupted. Aborting ..."
555                 CleanUp
556                 exit 1
557         fi
558
559         echo -n "End date: "; date
560         if [ $ret -eq 0 -o $ret -eq 24 ]; then
561                 [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
562
563                 echo "System \"$system\" completed with status $ret, OK."
564                 [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
565                 ok=1
566         else
567                 echo "System \"$system\" completed with ERRORS, code $ret!"
568         fi
569
570         # execute job "post-exec" command, if any
571         if [ -n "$job_post_exec" ]; then
572                 ExecJob post "$job_post_exec"
573         fi
574
575         if [ $generations -gt 0 ]; then
576                 # Update "latest" symlink
577                 if [ "$DRYRUN" -eq 0 ]; then
578                         rm -f "$sys_root/latest"
579                         ln -s "$sys_target" "$sys_root/latest"
580                 fi
581                 # Clean up old generations
582                 declare -i gen_count=$generations+2
583                 to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
584                 if [ -n "$to_delete" -a $ok -eq 1 ]; then
585                         [ "$DRYRUN" -eq 0 ] \
586                                 && echo "Deleting old backup generations (keep $generations) ..." \
587                                 || echo " *** Trial run, not deleting old generations:"
588                         for delete in $to_delete; do
589                                 dir="$sys_root/$delete"
590                                 if [ ! -e "$dir/.stamp" ]; then
591                                         echo "Not deleting \"$dir\", not a backup directory!?"
592                                         continue
593                                 fi
594                                 last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
595                                  | cut -d':' -f2- | cut -d. -f1)
596                                 echo "Removing backup from" $last "..."
597                                 if [ "$DRYRUN" -eq 0 ]; then
598                                         DeleteSubvolume "$dir"
599                                         [ $? -eq 0 ] || \
600                                           echo "Failed to delete \"$dir\"!"
601                                 fi
602                         done
603                         echo -n "Clean up finished: "; date
604                 elif [ -n "$to_delete" ]; then
605                         echo "There have been errors, not cleaning up old generations!"
606                 else
607                         echo "Nothing to clean up."
608                 fi
609         fi
610
611         destinations="$destinations $target"
612         echo
613 done
614
615 sync
616
617 paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
618 if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
619         df -h $paths
620         echo
621 fi
622
623 CleanUp
624
625 echo -n "Done: "; date
626 echo
627 [ $count_all -eq 1 ] && s="" || s="s"
628 echo " - $count_all job$s defined,"
629 [ $count_started -eq 1 ] && s="" || s="s"
630 echo " - $count_started job$s started,"
631 echo " - $count_ok done without errors."
632 echo
633
634 if [ $count_started -ne $count_ok ]; then
635         echo "----->  THERE HAVE BEEN ERRORS!  <-----"
636         echo
637 fi
638
639 # -eof-